BasicScheme (HttpClient Library (Version 3.1))
Date: 2019-09-02

org.apache.commons.httpclient.auth

## Class BasicScheme

- java.lang.Object
- - org.apache.commons.httpclient.auth.RFC2617Scheme
  - - org.apache.commons.httpclient.auth.BasicScheme

- All Implemented Interfaces:
    AuthScheme

      public class BasicScheme
      extends RFC2617Scheme

  Basic authentication scheme as defined in RFC 2617.

  Author:
    Remy Maucherat, Rodney Waldhoff, Jeff Dever, Ortwin Glueck, Sean C. Sullivan, Adrian Sutton, Mike Bowler, Oleg Kalnichevski

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicScheme()` Default constructor for the basic authetication scheme.
    `BasicScheme(java.lang.String challenge)` Deprecated. Use parameterless constructor and `AuthScheme.processChallenge(String)` method

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `authenticate(Credentials credentials, HttpMethod method)` Produces basic authorization string for the given set of `Credentials`.
    `java.lang.String` | `authenticate(Credentials credentials, java.lang.String method, java.lang.String uri)` Deprecated. Use `authenticate(Credentials, HttpMethod)`
    `static java.lang.String` | `authenticate(UsernamePasswordCredentials credentials)` Deprecated. Use `authenticate(UsernamePasswordCredentials, String)` Returns a basic `Authorization` header value for the given `UsernamePasswordCredentials`.
    `static java.lang.String` | `authenticate(UsernamePasswordCredentials credentials, java.lang.String charset)` Returns a basic `Authorization` header value for the given `UsernamePasswordCredentials` and charset.
    `java.lang.String` | `getSchemeName()` Returns textual designation of the basic authentication scheme.
    `boolean` | `isComplete()` Tests if the Basic authentication process has been completed.
    `boolean` | `isConnectionBased()` Returns `false`.
    `void` | `processChallenge(java.lang.String challenge)` Processes the Basic challenge.

    - ### Methods inherited from class org.apache.commons.httpclient.auth.RFC2617Scheme

      `getID, getParameter, getParameters, getRealm`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicScheme

          public BasicScheme()

      Default constructor for the basic authetication scheme.
      Since:
        3.0

    - #### BasicScheme

          public BasicScheme(java.lang.String challenge)
                      throws MalformedChallengeException

      Deprecated. Use parameterless constructor and `AuthScheme.processChallenge(String)` method
      Constructor for the basic authetication scheme.
      Parameters:
        `challenge` - authentication challenge
      Throws:
        `MalformedChallengeException` - is thrown if the authentication challenge is malformed

  - ### Method Detail

    - #### getSchemeName

          public java.lang.String getSchemeName()

      Returns textual designation of the basic authentication scheme.
      Returns:
        `basic`

    - #### processChallenge

          public void processChallenge(java.lang.String challenge)
                                throws MalformedChallengeException

      Processes the Basic challenge.
      Specified by:
        `processChallenge` in interface `AuthScheme`
      Overrides:
        `processChallenge` in class `RFC2617Scheme`
      Parameters:
        `challenge` - the challenge string
      Throws:
        `MalformedChallengeException` - is thrown if the authentication challenge is malformed
      Since:
        3.0

    - #### isComplete

          public boolean isComplete()

      Tests if the Basic authentication process has been completed.
      Returns:
        `true` if Basic authorization has been processed, `false` otherwise.
      Since:
        3.0

    - #### authenticate

          public java.lang.String authenticate(Credentials credentials,
                                               java.lang.String method,
                                               java.lang.String uri)
                                        throws AuthenticationException

      Deprecated. Use `authenticate(Credentials, HttpMethod)`
      Produces basic authorization string for the given set of `Credentials`.
      Parameters:
        `credentials` - The set of credentials to be used for athentication
        `method` - Method name is ignored by the basic authentication scheme
        `uri` - URI is ignored by the basic authentication scheme
      Returns:
        a basic authorization string
      Throws:
        `InvalidCredentialsException` - if authentication credentials are not valid or not applicable for this authentication scheme
        `AuthenticationException` - if authorization string cannot be generated due to an authentication failure
      See Also:
        `HttpMethod.getName()`, `HttpMethod.getPath()`

    - #### isConnectionBased

          public boolean isConnectionBased()

      Returns `false`. Basic authentication scheme is request based.
      Returns:
        `false`.
      Since:
        3.0

    - #### authenticate

          public java.lang.String authenticate(Credentials credentials,
                                               HttpMethod method)
                                        throws AuthenticationException

      Produces basic authorization string for the given set of `Credentials`.
      Parameters:
        `credentials` - The set of credentials to be used for athentication
        `method` - The method being authenticated
      Returns:
        a basic authorization string
      Throws:
        `InvalidCredentialsException` - if authentication credentials are not valid or not applicable for this authentication scheme
        `AuthenticationException` - if authorization string cannot be generated due to an authentication failure
      Since:
        3.0

    - #### authenticate

          public static java.lang.String authenticate(UsernamePasswordCredentials credentials)

      Deprecated. Use `authenticate(UsernamePasswordCredentials, String)` Returns a basic `Authorization` header value for the given `UsernamePasswordCredentials`.
      Parameters:
        `credentials` - The credentials to encode.
      Returns:
        a basic authorization string

    - #### authenticate

          public static java.lang.String authenticate(UsernamePasswordCredentials credentials,
                                                      java.lang.String charset)

      Returns a basic `Authorization` header value for the given `UsernamePasswordCredentials` and charset.
      Parameters:
        `credentials` - The credentials to encode.
        `charset` - The charset to use for encoding the credentials
      Returns:
        a basic authorization string
      Since:
        3.0

Copyright (c) 1999-2005 - Apache Software Foundation